<?php
/*************************************************************************/
// Calendarizm Core Ver0.6
// copyright@tenderfeel(http://tenderfeel.xsrv.jp/)
// お問い合わせ：tenderfeel@gmail.com

// 文字コードUTF-8。
/*************************************************************************/
include_once('calendarizm.php');
ini_set("output_buffering", "On");
ini_set("output_handler", "mb_output_handler");
ini_set("default_charset", "UTF-8");
mb_language("Japanese");
mb_internal_encoding ("UTF-8");
mb_http_input("auto");
mb_http_output("UTF-8");
mb_detect_order("auto");
mb_substitute_character("none");
ob_start("mb_output_handler");

if($_COOKIE['calendarizm_admin']){
	$pass_word = $_COOKIE['calendarizm_admin'];
}
// Login & Logout -----------------------------------------
if(isset($_POST['action'])&&$_POST["action"]=="LOGIN" && isset($_POST['loginPass'])){

	$pass_word = md5($_POST['loginPass']);
}
if( $pass_word== md5(LOGIN_PASS)) {
		setcookie("calendarizm_admin", $pass_word, time()+(3600*24*30));
		admin();
}elseif( $pass_word !=md5(LOGIN_PASS) && isset($_POST['loginPass'])){
	html_header("Error");
	print '<div id="header">'."\n";
	print '<ul id="menu"><li><a href="'.BACKURL.'">HOME</a></li></ul>';
	print "</div>\n<div id=\"main\">";
	print "<p id=\"error-message\">パスワードが違います</p>";
	loginform($_SERVER['SCRIPT_NAME'],"login");
	print "</div>\n";
	html_footer();
}else{
	html_header("Login");
	print "\n<div id=\"header\">\n";
	print '<ul id="menu"><li><a href="'.BACKURL.'">HOME</a></li></ul>'."\n";
	print "</div>\n<div id=\"main\">\n";
	print "<h2 class=\"adminlogin\">ログイン</h2>";
	loginform($_SERVER['SCRIPT_NAME'],"login");
	print "</div>\n";
	html_footer();
}

if(isset($_POST['action'])&&$_POST['action']== "LOGOUT"){
		$pass_word="";
		setcookie("calendarizm_admin",$pass_word);
		header('Location: '.BACKURL);
}

// Admin Panel ------------------------------------------------
function admin(){
	html_header("管理ページ");
	print "\n<div id=\"header\">\n";
	print "<ul id=\"menu\">\n";
	print "<li><a href=\"".BACKURL."\">HOME</a></li>\n";
	print "<li><a href=\"".$_SERVER['PHP_SELF']."\">管理トップ</a></li>\n</ul>\n";
	print "<form method=\"post\" action=\"\">\n";
	print "<input type=\"submit\" name =\"action\" value=\"LOGOUT\" />\n";
	print "</form>\n";
	print "</div>\n";
	print "<div id=\"main\">\n";
	if($_POST["action"] == "delete"){
		$mes = schedule_delete($_POST["delid"]);
		print $mes;
	}
	if (isset($_POST["regist"])){
			data_write();
	}
	if(isset($_GET["mode"])){
		if($_GET["mode"]=="edit"||$_GET["mode"]=="new"){		
			edit_html();
		}
	}else{
		setcookie ("calendarizm_ticket", "", time() - 3600);
		$calendar = new AdminCalendar();
		$calendar->view();
	}
	print "</div>\n";
	html_footer();
}
//Schedule data Write----------------------------------------------
function data_write(){
		$error_message = array();
		$err=0;
		 if (isset($_POST["year"]) && is_numeric($_POST["year"]) && $_POST["year"] > 2000) {
			$year = formatting($_POST["year"]);	
		  } else {
			$error_message[] = "年を正しく入力してください。";
			$err=1;
		  }
		  if (isset($_POST["month"]) && is_numeric($_POST["month"]) && $_POST["month"] > 0 && $_POST["month"] < 13) {
			$month = formatting($_POST["month"]);
		  } else {
			$error_message[] = "月を正しく入力してください。";
			$err=1;
		  }
		  if (isset($_POST["day"]) && is_numeric($_POST["day"]) && $_POST["day"] > 0 && $_POST["day"] < 32) {
			$day = formatting($_POST["day"]);
		  } else {
			$error_message[] = "日を正しく入力してください。";
			$err=1;
		  }
		  if (isset($_POST["body"]) && $_POST["body"]) {
			$body = formatting($_POST["body"]);
			$body = rtrim($body);
			
		  } else {
			$error_message[] = "予定の内容を入力してください。";
			$err=1;
		  }

		if ($err==1) {   
			print("<ul id=\"error-message\">");
			foreach ($error_message as $message) {   
				print("<li>".$message."</li>");  
			}   
			print("</ul>");
			
		}else{
		
			$schedule_date = sprintf("%04d",$year).$month.$day;			
			$body = str_replace(array("\r\n", "\r", "\n"), "[br]", $body);
			$new_line = time().",".$schedule_date.",".$body."\n";
			$ref=$_SERVER['SCRIPT_NAME']."?location=".$_GET["loc"];
			
			if (!isset($_POST["new"])&&$_POST["new"]!="true") {
				schedule_edit (trim($_GET["date"]),$new_line);
				print '<p class="success">編集しました。'."　　<a href=\"$ref\">前のページに戻る</a></p>";
			}else{
			
			if(filesize(FILENAME) != "0") {
		 		$contents = @file(FILENAME);
				$search = file_get_contents(FILENAME);
   			}
			
			if(strpos($search,$schedule_date)!==false){
				$sflag = true;
			}
			
			$fp = @fopen(FILENAME, "w");
			flock($fp, LOCK_EX);
			
			if($sflag!=true){
				fwrite($fp,$new_line);
			}
			
			for($i = 0; $i < LOGMAX-1 ; $i++){
				if(strpos($contents[$i],$schedule_date)!==false && $sflag==true){
					list($stamp,$date,$log)=explode(",",$contents[$i]);
					$new_body = trim($log)."[br]".$body;
					$overwrite = $stamp.",".$schedule_date.",".$new_body."\n";
					fwrite($fp,$overwrite);
				}else{
					fwrite($fp,$contents[$i]);
				}
			}
			flock($fp, LOCK_UN);
			fclose($fp);
			
			setcookie ("calendarizm_ticket", "1");
			$url =$_SERVER['SCRIPT_NAME']."?mode=edit&date=".trim($schedule_date)."&loc=".$_GET['loc'];
			header("Location: ".$url);
			}
		}
}

// Edit function -------------------------------------------------
function schedule_edit($date,$new_line) {
  $schedule_list = file(FILENAME);
  $fp = fopen(FILENAME, "w");
  flock($fp, LOCK_EX);
 foreach ($schedule_list as $line => $original_line) {
   if(strpos($original_line,$date)!==false){
		fwrite($fp, $new_line);
    } else {
      fwrite($fp, $original_line);
    }
  }
  flock($fp, LOCK_UN);
  fclose($fp);
  
} 
//text formatting--------------------------------------------------
function formatting($text){

	if (ini_get('magic_quotes_gpc'))
		$text = stripslashes($text);

	$text = strip_tags($text);
	$text = str_replace('&&', '&#038;&', $text);
	$text = str_replace('&', '&#038;', $text);
	$text = str_replace('<', '&lt;', $text);
	$text = str_replace('>', '&gt;', $text);
	$text = str_replace(',','&#044;',$text);
	return $text;

}

function format_decode($text) {
	$text = str_replace('<br />', "\r", $text);
	$text = str_replace('&#038;&', '&&', $text);
	$text = str_replace('&#038;', '&', $text);
	$text = str_replace('&lt;', '<', $text);
	$text = str_replace('&gt;', '>', $text);
	$text = str_replace('&#044;',',',$text);
	return $text;
}
// Delete function------------------------------------------------
function schedule_delete($date){

$lines = file(FILENAME);
 
for($n=0;$n<count($date);$n++){
	foreach ($lines as $line => $original_line) {
		if(strpos($original_line,$date[$n])!==false){	
			array_splice($lines,$line,1);
			$flag = 1;
		}
	}
}
if($flag==1){
	$fp = fopen(FILENAME, "w");
	flock($fp, LOCK_EX);
	foreach ($lines as $line => $original_line) {
		fwrite($fp,  $original_line);
	}
	flock($fp, LOCK_UN);
	fclose($fp);
	return "<p class=\"success\">選択されたスケジュールを削除しました</p>";
	
	setcookie ("calendarizm_ticket", "", time() - 3600);

}else{
	return "<p id=\"error-message\">削除データがありません。</p>";
}
	
}
//Edit form ------------------------------------------------------
function edit_html(){
if($_COOKIE['calendarizm_ticket']=="1"){
	setcookie ("calendarizm_ticket", "", time() - 3600);
	$ref=$_SERVER['SCRIPT_NAME']."?location=".$_GET["loc"];
	print '<p class="success">登録しました。'."<a href=\"$ref\">前のページに戻る</a></p>";
}
$date = $_GET["date"];

if($_GET["mode"]=="new"){
	print "<h1>新規</h1>\n";
	$new = 1;
}else{
	print "<h1>編集</h1>\n";
}
if(filesize(FILENAME) != "0") {
	$lines = file(FILENAME,FILE_IGNORE_NEW_LINES);

	foreach ($lines as $line => $schedule) {
		if(strpos($schedule,$date)!==false){
			list($timestamp,$schedule_date, $schedule_body) = explode(",", $schedule);
			$body = str_replace("[br]","\r",$schedule_body);
		}
	}

}
	$year = intval(substr($date, 0, 4));
	$month = sprintf("%02d",intval(substr($date, 4, 2)));
	$day = sprintf("%02d",intval(substr($date, 6, 2)));


	$d=1;
	$m =1;
	$y =date('Y')-2;
	
	$body = format_decode($body);
	
	print "<form action=\"\" method=\"post\" id=\"editform\">\n";
	print "<p><select id=\"year\" name=\"year\">\n";
	
		for ($i=0; $i<=4; $i++) {
			if($y==$year) {
				echo("<option value='$y' selected='selected'>$y</option>\n");
			}else {
				echo("<option value='$y'>$y</option>\n");
			}
			$y++;
		}
	
	echo "</select><label for=\"year\">年</label>\n";
	echo "<select id=\"month\" name=\"month\">\n";
	
		for ($i=0; $i<12; $i++) {
			$md = sprintf("%02d",$m);
			if($md==$month){
				echo("<option value='$md' selected='selected'>$m</option>\n");
			}else{
				echo("<option value='$md'>$m</option>\n");
			}
			$m++;
		}
	
	print "</select><label for=\"month\">月</label>\n";
	print "<select id=\"day\" name=\"day\">\n";
	
		for ($i=0; $i<31; $i++) {
			$da = sprintf("%02d",$d);
			if($da==$day){
				echo("<option value='$da' selected='selected'>$d</option>\n");
			}else{
				echo("<option value='$da'>$d</option>\n");
			}
			$d++;
		}
	print "</select><label for=\"day\">日</label></p>\n";
	print "<div id=\"schedule\">\n";
	print "<label for=\"schedule-body\">予定</label><br />\n";
	print '<textarea name="body" id="schedule-body" cols="50" rows="5">'.htmlspecialchars($body, ENT_QUOTES).'</textarea>';
	print "\n</div>\n";
	html_help();
	
	print "<p class=\"button\">\n";
	if($_GET["mode"]!="new"){
		print '<input type="submit" name="regist" id="regist" value="更新する" />';
	}else{
		print '<input type="hidden" name="new" value="true">';
		print '<input type="submit" name="regist" id="regist" value="登録する" />';
	}
	print "</p>\n";
	print "</form>\n";
	html_script();
}

//HTML------------------------------------------------------------
function html_header($str){
print<<<EOM
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
EOM;
print "\n<title>".SCRIPT." &raquo; ".$str."</title>\n";
print<<<EOM
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
<meta name="robots" content="noindex/nofollow" />
<link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="container">
EOM;
}
function html_footer(){
	print "<address>".SCRIPT."&nbsp;".VERSION." &copy; Copyright 2008 <a href=\"http://tenderfeel.xsrv.jp/\">Tenderfeel</a> All Rights Reserved.</address>\n";
	print "</div>\n</body>\n";
	print "</html>\n";
}
function html_help(){
	print "<div id=\"help\">\n";
	print "<h2><span style=\"cursor:pointer\" onclick=\"javascript:Toggle('help-text');\">HELP</span></h2>\n";
	print "<div id=\"help-text\" style=\"display:none;\">\n";
	print "<p>タグは使用出来ませんが、独自タグが一部有効です。</p>\n";
	print "<dl>\n";
	print "<dt><input value=\"||強調||\" type=\"text\" /></dt>\n";
	print "<dd><strong>||で囲まれた文字にstrongタグを追加します</strong></dd>\n";
	print "<dt><input value=\"''強調''\" type=\"text\" /></dt>\n";
	print "<dd><em>''で囲まれた文字にemタグを追加します</em></dd>\n";
	print "<dt><input value=\"[[説明文>リンク先のURL]]\" type=\"text\"  /></dt>\n";
	print "<dd><a href=\"javascript:void(0)\">説明文</a>へリンクを貼ります</dd>\n";
	print "<dt><input value=\"color(色名){文字}\" type=\"text\" /></dt>\n";
	print "<dd><span style=\"color:red\">文字の色</span>を変更します。spanタグが使用されます。<br />文字色は#000000の１６進と色名に対応しています。</dd>\n";
	print "</dl>\n";
	print "</div>\n";
	print "</div>\n";
}

function html_script(){
print <<<EOM
<script type="text/javascript">
<!--
function Toggle(id) {
　div = document.getElementById(id);
　switch (div.style.display) {
　　case "none":
　　　div.style.display="block";
　　　break;
　　case "block":
　　　div.style.display="none";
　　　break;
　}
}
-->
</script>
EOM;
}
?>
